package ch.zhaw.projekt2.turnierverwaltung.main.tournamentList;

import ch.zhaw.projekt2.turnierverwaltung.FXController;
import ch.zhaw.projekt2.turnierverwaltung.FileIO;
import ch.zhaw.projekt2.turnierverwaltung.Tournament;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.*;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.GridPane;

import java.io.File;
import java.io.IOException;

public class TournamentListController extends FXController {

    @FXML
    public void initialize(){
        modusChoiceBox.setItems(Tournament.Type.getObservableList());
    }

    @FXML
    private Button createBtn;

    @FXML
    private GridPane grid;

    @FXML
    private ChoiceBox<Tournament.Type> modusChoiceBox;

    @FXML
    private Label newTournamentFormularTitle;

    @FXML
    private Button openBtn;

    @FXML
    private Label tournamentListTitle;

    @FXML
    private ListView<FileIO.TournamentFile> tournamentListView;

    @FXML
    private Label tournamentModLabel;

    @FXML
    private Label tournamentNameLabel;

    @FXML
    private TextField tournamentNameField;

    @FXML
    void createTournament(ActionEvent event) {
        if(getFileIO().tournamentExists(tournamentNameField.getText())){
            System.out.println("Tournament with same name exists already.");
            return; //TODO handle and logging
        }
        try {
            Tournament tournament = new Tournament(tournamentNameField.getText(), modusChoiceBox.getValue());
            getFileIO().saveTournament(tournament);
            loadContent();
        } catch (Tournament.InvalidNameException e) {
            e.printStackTrace(); //TODO handle and logging
        } catch (IOException e) {
            e.printStackTrace(); //TODO handle and logging
        }

    }

    @FXML
    void openTournament(ActionEvent event) {
        try {
            File tournamentFile = tournamentListView.getSelectionModel().getSelectedItems().get(0);
            getFactory().setTournament(getFileIO().loadTournament(tournamentFile));
            getFactory().loadParticipantFormular((BorderPane) getPane()); //TODO load TournamentView instead of ParticipantFormular?
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } //TODO handle and logging
    }

    @Override
    public void loadContent() {
        tournamentListView.setItems(getFileIO().getList());
    }
}

